#!/usr/bin/python

program_name = "pyproc"
program_version = "0.2"


print "Loading gtk..."

import pygtk
pygtk.require("2.0")
#from gtk import *
import gtk

print "Loading gtk...  done."

def runqueue():
  while gtk.events_pending():
    gtk.mainiteration()


#
# Config file handling, and defaults...
#

######################################################################
# Config class:
#
def is_config(obj):
  return hasattr(obj,'is_config') and obj.is_config

class config:
  is_config = 1

  def __init__(self):
    import os
    self.options = {}
    self.usrfilename = "%s/.%s.conf" % (os.environ["HOME"], program_name)
    self.globalfilename = "/etc/%s/%s.conf" % (program_name, program_name)
    self.namespace = {
      "options" : self.options,
      }

  ##################################################
  #
  def load(self):
    import os.path
    for name in [self.globalfilename, self.usrfilename]:
      if os.path.exists(name):
        self.parse(name)

  ##################################################
  #
  def parse(self, filename):
    #print "parsing %s..." % filename
    
    try:
      execfile(filename, self.namespace)
    except:
      print "Error in config file %s" % filename
      import traceback, sys
      foo = traceback.format_exception(sys.exc_type,
                                       sys.exc_value,
                                       sys.exc_traceback)
      for item in foo:
        item = item[:-1]
        print item
      print "Press Enter to continue..."
      raw_input()


######################################################################
#
class process:
  def __init__(self):
    self.data = {}

######################################################################
#
class procwin:

  def __init__(self, cfg):
    self.cfg = cfg

    self.procs = []

    self._updating_now = 0
    self._sort_col = self.cfg.options["sort column"]

    self.win = gtk.Window()
    self.win.connect("destroy", self.destroy)
    self.win.set_title("Processes")
    self.win.set_default_size(self.cfg.options["width"],
                              self.cfg.options["height"])

    self.sw = gtk.ScrolledWindow()
    self.sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

    self.vbox = gtk.VBox()
    self.win.add(self.vbox)

    self.hbox = gtk.HBox()
    self.vbox.pack_start(self.hbox, fill=0, expand=0)

    self.quit_button = gtk.Button("Quit")
    self.quit_button.connect("clicked", self.destroy)
    self.hbox.add(self.quit_button)

    self.update_button = gtk.Button("Refresh")
    self.update_button.connect("clicked", self.update)
    self.hbox.add(self.update_button)

    self.make_menus()

    self.vbox.pack_start(self.sw, fill=1, expand=1)

    self.clist = gtk.CList(self.cfg.options["num columns"])
    self.sw.add(self.clist)
    self.clist.connect("select-row", self._item_select_cb)
    self.clist.connect("click-column", self._header_select_cb)
    self.clist.set_selection_mode(gtk.SELECTION_BROWSE)
    #self.clist.set_sort_column(1)
    #self.clist.set_auto_sort(1)

    #self.column_titles = ["PID", "TTY", "Command"]
    for i in range(self.cfg.options["num columns"]):
      t = self.cfg.options["column %s" % i]
      self.clist.set_column_title(i, t)
    self.clist.column_titles_show()
    for i in range(self.cfg.options["num columns"]):
      wid = self.cfg.options["column %s width" % i]
      if wid  and  wid > 0:
        self.clist.set_column_width(i, wid)

  ##################################################
  #
  def make_menus(self):
    self.signals = self.cfg.options["signals"]
    
    self.ag = gtk.AccelGroup()
    self.win.add_accel_group(self.ag)
    self.itemf = gtk.ItemFactory(gtk.MenuBar, "<main>", self.ag)
    foo = [("/_Kill", None, None, 0, "<Branch>")]
    # Keypresses for quick access to commands...
    ks = [
      ("/foo",       None, None, 0, "<Branch>"),
      ("/foo/quit",  "Q", self.destroy, 0, ""),
      ("/foo/update","U", self.update, 0, ""),
      ("/foo/refresh","R", self.update, 0, ""),
      ]
    for i in xrange(len(self.signals)):
      s = self.signals[i]
      foo.append(("/Kill/_%s" % s, None, self._kill_cb, i, ""))
      ks.append(("/foo/_%s" % s, self.signals[i][0], self._kill_cb, i, ""))
    self.itemf.create_items(foo)
    self.menubar = self.itemf.get_widget("<main>")
    self.hbox.pack_start(self.menubar, fill=0, expand=1)

    foo = gtk.ItemFactory(gtk.MenuBar, "<keydefs>", self.ag)
    foo.create_items(ks)


  ##################################################
  #
  def update_procs(self):
    #print "update_procs()"
    import os, string
    self.procs = []

    try:
      ps = os.popen("ps axuwww")
      lines = ps.readlines()[1:]
      ps.close()
    except:
      # TODO: error message
      return

    for line in lines:
      parts = string.split(line)
      p = process()
      p.data["user"] = parts[0]
      p.data["pid"] = int(parts[1])
      p.data["%cpu"] = float(parts[2])
      p.data["%mem"] = float(parts[3])
      p.data["vsize"] = int(parts[4])
      p.data["rsize"] = int(parts[5])
      p.data["tty"] = parts[6]
      p.data["state"] = parts[7]
      p.data["start"] = parts[8]
      p.data["time"] = parts[9]
      p.data["command"] = string.join(parts[10:])

      if int(p.data["pid"]) < self.cfg.options["min pid"]:
        continue

      if parts[10] in self.cfg.options["hide by name"]:
        continue

      base = parts[10]
      foo = string.rfind(parts[10], "/")
      if foo >= 0:
        base = base[foo+1:]
      if base in self.cfg.options["hide by name"]:
        continue

      self.procs.append(p)

      self.procs.sort(self._proc_sorter)


  ##################################################
  #
  def update_gui(self):
    #print "update_gui()"
    self.clist.clear()

    runqueue()

    self.clist.freeze()
    for p in self.procs:
      data = []
      for i in range(self.cfg.options["num columns"]):
        data.append(str(p.data[self.cfg.options["column %s" % i]]))
      self.clist.append(data)
    self.clist.thaw()

  ##################################################
  #
  def _proc_sorter(self, a, b, level=0):
    if self.cfg.options["reverse sort"]:
      greater = 1
      lesser = -1
    else:
      greater = -1
      lesser = 1
    
    sortcol = self._sort_col
    if level > 0:
      sortcol = "pid"
      
    adata = a.data[sortcol]
    bdata = b.data[sortcol]
    if adata < bdata:
      return greater
    elif adata == bdata:
      return self._proc_sorter(a, b, level + 1)
    else:
      return lesser

  ##################################################
  #
  def run(self):

    self.win.show_all()
    self.update()
    gtk.mainloop()

  ##################################################
  #
  def update(self, *args):
    # Don't interrupt myself due to double-clicks
    if self._updating_now:
      return
    self._updating_now = 1  # cheapass mutex

    self.update_procs()
    #if self.cfg.options["reverse sort"]:
    #  self.procs.reverse()
    self.update_gui()

    self._updating_now = 0

  ##################################################
  #
  def _item_select_cb(self, clist, row, col, gdkevent):
    self.current_proc = self.procs[row]
    #print "Current: %s" % self.current_proc.command

  ##################################################
  #
  def _header_select_cb(self, clist, column):
    #print "Header: %s" % repr(args)
    newcol = self.cfg.options["column %s" % (column)]
    if self._sort_col == newcol:
      self.cfg.options["reverse sort"] = \
                                int(self.cfg.options["reverse sort"]) ^ 1
    self._sort_col = self.cfg.options["column %s" % (column)]
    self.procs.sort(self._proc_sorter)
    self.update_gui()


  ##################################################
  #
  def _kill_cb(self, signum, *args):
    import os
    cmd = "kill -%s %s" % (self.signals[signum],
                           self.current_proc.data["pid"])
    #print cmd
    os.system(cmd)
    self.update()
    
  ##################################################
  #
  def destroy(self, *args):
    gtk.mainquit()

######################################################################
#
def run(args):
  cfg = config()
  cfg.load()
  
  p = procwin(cfg)
  p.run()


######################################################################
#
if __name__ == "__main__":
  import sys
  run(sys.argv[1:])
